<?php

namespace Ebizmarts\MageMonkey\Helper;

class Import extends \Ebizmarts\MageMonkey\Helper\Data {

    /**
     * @param \Ebizmarts\MageMonkey\Helper\Data $helper
     * @param \Magento\Customer\Model\Customer $customer
     * @param \Magento\Customer\Model\Session $customerSession
     */
    protected $_api = null;
    protected $_subscriber = null;

    public function __construct(
    \Magento\Framework\App\Helper\Context $context, \Magento\Store\Model\StoreManagerInterface $storeManager, \Ebizmarts\MageMonkey\Model\Logger\Logger $logger, \Magento\Customer\Model\GroupRegistry $groupRegistry, \Magento\Framework\App\Request\Http $request, \Ebizmarts\MageMonkey\Model\Api $api, \Magento\Newsletter\Model\Subscriber $subscriber
    ) {

        $this->_api = $api;
        $this->_subscriber = $subscriber;
        parent::__construct($context, $storeManager, $logger, $groupRegistry, $request);
    }

    public function sendToMailchimp($subscribersIds) {
        $api = $this->_api;
        $status = '';
        $count = 0;
        foreach ($subscribersIds as $subscriberId) {
            
            $subscriber = $this->_subscriber->load($subscriberId);
            
            if ($subscriber->getSubscriberStatus() == \Magento\Newsletter\Model\Subscriber::STATUS_SUBSCRIBED || $subscriber->getSubscriberStatus() == \Magento\Newsletter\Model\Subscriber::STATUS_UNSUBSCRIBED) {

                if ($subscriber->getSubscriberStatus() == \Magento\Newsletter\Model\Subscriber::STATUS_SUBSCRIBED) {
                     $status = 'subscribed';
                }
                else {
                     $status = 'unsubscribed';
                }
                
                $email = $subscriber->getSubscriberEmail();
                $mergeVars = $this->getMergeVars(true, $subscriberId);

                if ($mergeVars) {
                    $data = array('list_id' => $this->getDefaultList($subscriber->getStoreId()), 'email_address' => $email, 'email_type' => 'html', 'status' => $status, 'merge_fields' => $mergeVars);
                } else {
                    $data = array('list_id' => $this->getDefaultList($subscriber->getStoreId()), 'email_address' => $email, 'email_type' => 'html', 'status' => $status);
                }

                try {
                    if ($subscriber->getMagemonkeyId()) {
                        $return = $api->listUpdateMember($this->getDefaultList($subscriber->getStoreId()), json_encode($data), $subscriber->getMagemonkeyId());
                    } else {
                        $return = $api->listCreateMember($this->getDefaultList($subscriber->getStoreId()), json_encode($data));
                        if (isset($return->id)) {
                            $subscriber->setMagemonkeyId($return->id);
                        }
                    }
                    
                    $subscriber->save();
                    
                    $count++;
                } catch (\Exception $e) {
                    $this->log($e->getMessage());
                    if (stripos($e->getMessage(), ' Status: 400 ') === false) {
                        throw new \Exception($e->getMessage());
                    }
                }
            }
        }
        
        return $count;
    }

}
